package org.pmmik.pojo;

import javax.persistence.AttributeOverride;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity(name=Phone.TABLE_NAME)
@Table(name=Phone.TABLE_NAME,schema=PersistentObject.SCHEMA)
@AttributeOverride(name=PersistentObject.ID, column=@Column(name=Phone.ID))
public class Phone extends PersistentObject {

	public final static String TABLE_NAME = "Phone";
	@SuppressWarnings("hiding")
	public final static String ID = "phone_id"; 
	public final static String OWNER_ID="owner_id"; 
	public final static String TYPE="phone_type"; 
	public final static String PHONE_NUMBER="phone_number"; 
	public final static String AREA_CODE="area_code"; 
	
	@ManyToOne
	@JoinColumn(name = Phone.OWNER_ID)
	private Student owner;
	
	@Column(name=Phone.TYPE, nullable=false)
	private String type;
	
	@Column(name=Phone.PHONE_NUMBER, nullable=false, unique=true)
	private String phoneNumber;
	
	@Column(name=Phone.AREA_CODE, nullable=false)
	private String areaCode;
	
	public Phone(){
		super();
	}
	/**
	 * @param owner
	 * @param type
	 * @param phoneNumber
	 * @param areaCode
	 */
	public Phone(Student owner, String type, String phoneNumber, String areaCode) {
		super();
		this.owner = owner;
		this.type = type;
		this.phoneNumber = phoneNumber;
		this.areaCode = areaCode;
	}
	
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Phone [owner=" + this.owner + ", type=" + this.type + ", phoneNumber=" 
				+ this.phoneNumber + ", areaCode=" + this.areaCode + "]"; 
	}
	/**
	 * @param owner the owner to set
	 */
	public void setOwner(Student owner) {
		this.owner = owner;
		if(!owner.getPhones().contains(this)){
			owner.addPhone(this);
		}
	}
	
	/**
	 * @return the owner
	 */
	public Student getOwner() {
		return this.owner;
	}

	/**
	 * @return the type
	 */
	public String getType() {
		return this.type;
	}
	/**
	 * @param type the type to set
	 */
	public void setType(String type) {
		this.type = type;
	}
	/**
	 * @return the phoneNumber
	 */
	public String getPhoneNumber() {
		return this.phoneNumber;
	}
	/**
	 * @param phoneNumber the phoneNumber to set
	 */
	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}
	/**
	 * @return the areaCode
	 */
	public String getAreaCode() {
		return this.areaCode;
	}
	/**
	 * @param areaCode the areaCode to set
	 */
	public void setAreaCode(String areaCode) {
		this.areaCode = areaCode;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result
				+ ((this.phoneNumber == null) ? 0 : this.phoneNumber.hashCode());
		return result;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		Phone other = (Phone) obj;
		if (this.phoneNumber == null) {
			if (other.phoneNumber != null)
				return false;
		} else if (!this.phoneNumber.equals(other.phoneNumber))
			return false;
		return true;
	}
	
}
