package org.pmmik.pojo;

import java.util.List;

import javax.persistence.AttributeOverride;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.Table;


@Entity(name=Student.TABLE_NAME)
@Table(name=Student.TABLE_NAME,schema=PersistentObject.SCHEMA)
@AttributeOverride(name=PersistentObject.ID, column=@Column(name=Student.ID))
public class Student extends PersistentObject {
	
	public final static String TABLE_NAME = "Student"; 
	@SuppressWarnings("hiding")
	public final static String ID = "student_id"; 
        public final static String NAME="student_name"; 
	public final static String EHA="student_eha"; 
	
	@Column(name=NAME, nullable=false)
	private String name;
	
	@Column(name=EHA, nullable=false, unique=true)
	private String eha;
	
	@OneToMany(mappedBy = "owner")
	private List<Phone> phones;
	/**
	 * 
	 */
	public Student() {
		super();
	}

	/**
	 * @param name
	 * @param eha
	 * @param average
	 */
	public Student(String name, String eha, double average) {
		super();
		this.name = name;
		this.eha = eha;
	}

	/**
	 * @param phones the phones to set
	 */
	public void addPhone(Phone phone) {
		this.phones.add(phone);
		if(!this.equals(phone.getOwner())){
			phone.setOwner(this);
		}
	}
	
	/**
	 * @return the phones
	 */
	public List<Phone> getPhones() {
		return this.phones;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return this.name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the eha
	 */
	public String getEha() {
		return this.eha;
	}

	/**
	 * @param eha the eha to set
	 */
	public void setEha(String eha) {
		this.eha = eha;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Student [name=" + this.name + ", eha=" + this.eha + "]"; 
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((this.eha == null) ? 0 : this.eha.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		Student other = (Student) obj;
		if (this.eha == null) {
			if (other.eha != null)
				return false;
		} else if (!this.eha.equals(other.eha))
			return false;
		return true;
	}

}
